/*
Stereoscopic tunnel for iOS.
Copyright (C) 2011  John Tsiombikas <nuclear@member.fsf.org>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#import "ui.h"

extern int stereo;
extern int use_bump;
extern float split;


@implementation UI

@synthesize bn_done;
@synthesize slider_split;
@synthesize grp_mode;
@synthesize sw_stereo;

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
	self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
	if(self) {
	}
	return self;
}*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
	[super viewDidLoad];
	
	self.view.center = CGPointMake(160, 240);
	self.view.transform = CGAffineTransformMakeRotation(M_PI / 2.0);
			
	[slider_split setValue: 1.0 - split];
	sw_stereo.on = stereo ? YES : NO;
	grp_mode.selectedSegmentIndex = use_bump ? 1 : 0;	
}


// Override to allow orientations other than the default portrait orientation.
/*- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return interfaceOrientation == UIInterfaceOrientationLandscapeRight;
}*/


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

-(IBAction) done_clicked: (id) sender
{
	self.view.hidden = YES;
}

-(IBAction) split_changed: (id) sender
{
	split = 1.0 - slider_split.value;
}

-(IBAction) stereo_changed: (id) sender
{
	stereo = sw_stereo.on;
}

-(IBAction) mode_changed: (id) sender
{
	use_bump = grp_mode.selectedSegmentIndex;
}


@end
